#ifndef __TIMER_H__
#define __TIMER_H__

#ifdef _WIN32
#include <ctime>

class Timer {
public:
  Timer() : mark(clock()) {};
  unsigned long mark;
  void start() { mark = clock(); };
  double time() { 
      double cpu = clock(); return (cpu - mark)/CLOCKS_PER_SEC;
  };
};

#else

#include <sys/times.h>
#include <unistd.h>

clock_t clps = 0;

class Timer {
public:
  tms tstart, tend;
  Timer() { 
    if( !clps ) {
      clps = sysconf(_SC_CLK_TCK); 
    }
    times(&tstart);
  };
  void start() { 
    times(&tstart);
  };
  double time() {
    times(&tend); double cpu = tend.tms_utime;
    return (cpu - tstart.tms_utime)/clps;
  };
};
#endif

#endif
